<#
.SYNOPSIS
    Adds two numbers and returns the result.

.DESCRIPTION
    The Add-Numbers function takes two integer parameters, $Number1 and $Number2,
    and returns the sum of those two numbers.

.PARAMETER Number1
    The first number to add.

.PARAMETER Number2
    The second number to add.

.EXAMPLE
    $sum = Add-Numbers -Number1 5 -Number2 10
    Write-Host "The sum is: $sum"

.NOTES
    This function was created as an example for a PowerShell documentation demonstration.

.LINK
    https://example.com/powershell-functions
#>


$APIURL=$args[0]
$ReleaseName=$args[1]
$ReleaseTag=$args[2]
$ReleaseBody=$args[3]


function CreateRelease {
    param (
        [string]$APIURL,
        [string]$ReleaseName,
        [string]$ReleaseID,
        [string]$ReleaseBody,
    )

    $headers = @{
        "accept" = "application/json"
        "Content-Type" = "application/json"
    }
    $body = @{
        "body" = "${ReleaseBody}"
        "draft" = $false
        "name" = "${ReleaseTag}"
        "prerelease" = $false
        "tag_name" = "${ReleaseTag}"    
        "target_commitish" = "string"
    } | ConvertTo-Json

    # Write-Host "body: " $body

    $Result = Invoke-RestMethod -Uri $APIURL -Method Post -Headers $headers -Body $body

    Write-Host $Result
}



Write-FullName -FirstName "John" -LastName "Doe"